/*
simple test driver for libunits

note: doesn't check status_t returns! bad program!
*/

#include <stdlib.h>
#include <stdio.h>
#include "libunits.h"

int main(){

	printf("\nSimple test driver for libunits.so\n");
	
	
	// ****** test: UNITVersion...()
	if (!UNITVersion){
		printf("no libunits!");
		exit(EXIT_FAILURE);
		} // end if
	
	uint32 currVers;
	uint32 minVers;
	printf("%s\n", UNITVersion(currVers, minVers));


	// ****** test: UNITGetDefaultFamily()
	UNITFamilyInfo defaultFamily;
	if (UNITGetDefaultFamily(defaultFamily) < B_NO_ERROR){
		printf("UNITGetDefaultFamily() failed\n");
		exit(EXIT_FAILURE);
		} // end if
	printf("\n****** Default family:\n\n");
	UNITDumpFamilyInfo(defaultFamily);
	printf("\n");

	// ****** test: UNITGetAll...()
	UNITTypeInfo *types;
	UNITFamilyInfo *families;
	UNITInfo *units;
	uint32 count;
	
	UNITGetAllTypes(types, count);
	printf("\n****** ALL TYPES\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpTypeInfo(types[i]);
		printf("\n");
		} // end for

	UNITGetAllFamilies(families, count);
	printf("\n****** ALL FAMILIES\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpFamilyInfo(families[i]);
		printf("\n");
		} // end for
	
	UNITGetAllUnits(units, count);
	printf("\n****** ALL UNITS\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpUnitInfo(units[i]);
		printf("\n");
		} // end for
	
	// clean up
	delete [] types;
	delete [] families;
	delete [] units;
	
	
	// ****** test: UNITGetUnitBy...()
	UNITGetUnitsByType(units, count, "distance");
	printf("\n****** UNITS BY (TYPE = DISTANCE)\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpUnitInfo(units[i]);
		printf("\n");
		} // end for
	delete [] units;
	
	UNITGetUnitsByType(units, count, "time");
	printf("\n****** UNITS BY (TYPE = TIME)\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpUnitInfo(units[i]);
		printf("\n");
		} // end for
	delete [] units;
	
	UNITGetUnitsByFamily(units, count, "SI");
	printf("\n****** UNITS BY (FAMILY = SI)\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpUnitInfo(units[i]);
		printf("\n");
		} // end for
	delete [] units;
	
	UNITGetUnitsByFamily(units, count, "metric");
	printf("\n****** UNITS BY (FAMILY = METRIC)\n\n");
	for (uint32 i = 0; i < count; i++){
		UNITDumpUnitInfo(units[i]);
		printf("\n");
		} // end for
	delete [] units;
	
	
	// ****** test: UNITConvert()
	
	UNITGetUnitsByType(units, count, "time");
	printf("\n****** UNITConvert()\n\n");
	double to;
	UNITConvert(1.0, to, units[count-1], units[count-2]);
	printf("one %s is %e %s\n",
		units[count-1].name,
		to,
		units[count-2].plural
		);
	UNITConvert(1.0, to, units[count-1], units[count-3]);
	printf("one %s is %e %s\n",
		units[count-1].name,
		to,
		units[count-3].plural
		);
	UNITConvert(1.0, to, units[count-1], units[count-4]);
	printf("one %s is %e %s\n",
		units[count-1].name,
		to,
		units[count-4].plural
		);
	delete [] units;
	
	
	
	printf("\n");
	
	return EXIT_SUCCESS;
	
} // end main()